#include <mpi.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <omp.h>

#define N 1000000000
#define X 100
int main(int argc, char ** argv)
{
  srand(1234567);
  int rank, size, i, j;
  MPI_Init(&argc, &argv);
  MPI_Comm_size(MPI_COMM_WORLD, &size);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);

  long localSum = 0L;
  long localSSum = 0L;
  long totalSum = 0L;

  long localArr[2];
  long totalArr[2] = {0L, 0L};
  int workToDo = N/size;
  int * arr;
  int start = workToDo*rank;
  int end = start+workToDo;
  
  arr = (int *) malloc(workToDo*sizeof(int));
  for( i = start, j= 0; i < end; i++,j++)
    arr[j] = rand()%X;

  #pragma omp parallel for private(i) shared(arr, workToDo) reduction(+:localSum, localSSum)
  for( i = 0; i < workToDo; i++)
  {
    localSum += arr[i];
    localSSum += arr[i]*arr[i];
  }
  localArr[0] = localSum;
  localArr[1] = localSSum;
  
  MPI_Reduce(localArr, totalArr, 2, MPI_LONG, MPI_SUM, 0, MPI_COMM_WORLD);

  free((void *) arr);
  if(rank == 0)
  {
    printf("The average is %lf\n", totalArr[0]/(double)N);
    printf("The sum of squares is %ld\n", totalArr[1]);
    printf("The standard deviation is %lf\n", sqrt( (totalArr[1]/(double)N) - ((double)totalArr[0]/(double)N)*((double)totalArr[0]/(double)N) ) );
  }
  MPI_Finalize();
  return 0;
}

